<?php

error_reporting(-1);

function __autoload($className) {
    require './lib/' . strtolower($className) . '.php';
}

$action = isset($_GET['action']) ? $_GET['action'] : 'list';

$dir = str_replace('\\', '/', dirname($_SERVER['SCRIPT_NAME']));
if ($dir != '/') {$dir .= '/';}
$baseUrl = 'http://' . $_SERVER['SERVER_NAME'] . $dir;

$config = require('./config/main.php');
if ($action != 'download') {
	header('Content-type: text/html; charset=utf-8');
	$pageTitle = 'artoodetoo uploader';
	$view = new View();
}

switch ($action) {

case 'add':
	$pageTitle .= ' :: Add new files';
	$maxFileSize = $config['maxFileSize'];
	$view->render('addform', compact('pageTitle', 'baseUrl', 'maxFileSize'));
	break;

case 'addpost':
	$pageTitle .= ' :: Files added';
	$subject = isset($_POST['subject']) ? $_POST['subject'] : '';
	$params = $config;
	$params['typeByExt'] = require('./config/mime.php');
	$storage = new FileStorage($params);
	$num = $storage->upload('attach', $subject);
	$errors = $storage->getErrors();
	$newRecords = array();
	if ($num) {
		$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
		$it = $manager->getIterator();
		foreach ($storage->getRecords() as $rec) {
			$it->append($rec);
			$id = $manager->lastKey();
			$newRecords[$id] = $rec;
		}
		$manager->close();
	}
	$view->render('afteradd', compact('pageTitle', 'baseUrl', 'subject', 'num', 'errors', 'newRecords'));
	break;

case 'download':
	$id = isset($_GET['id']) ? intval($_GET['id']) : NULL;
	$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
	$it = $manager->getIterator();
	if ($it->valid($id)) {
		$rec = $it->offsetGet($id);
		$storage = new FileStorage(array('uploadDir' => $config['uploadDir']));
		$storage->download($rec);
	} else {
		header ('HTTP/1.0 404 Not Found');
		exit('404 File not found');
	}
	break;

case 'delete':
	$id = isset($_GET['id']) ? intval($_GET['id']) : NULL;
	$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
	$it = $manager->getIterator();
	if ($it->valid($id)) {
		$rec = $it->offsetGet($id);
		if (isset($_POST['del_comply'])) {
			$storage = new FileStorage(array('uploadDir' => $config['uploadDir']));
			$storage->delete($rec);
			$it->offsetUnset($id);
			$manager->close();
		} else {
			$pageTitle .= ' :: Confirm delete';
			$name = $rec['name'];
			$view->render('confirmdelete', compact('pageTitle', 'baseUrl', 'id', 'name'));
			break;
		}
	} else {
		header ('HTTP/1.0 404 Not Found');
		exit('404 File not found');
	}
	header('Location: index.php?action=list');
	break;

case 'list':
	$pageTitle .= ' :: List files';
	$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
	$it = $manager->getIterator();
	$view->render('list', compact('pageTitle', 'baseUrl', 'it'));
	break;
}