<?php

class Component
{
	private
		$_events = array();

	public function __construct(array $params = NULL)
	{
		if (!empty($params)) {
			foreach ($params as $var => $value) {
				if ($var == 'events') {
					foreach ($value as $name => $handler) {
						$this->addEvent($name, $handler);
					}
				} else {
					$this->$var = $value;
				}
			}
		}
	}

	public function addEvent($name, $handler)
	{
		$name = strtolower($name);
		$this->_events[$name][] = $handler;
		return $this;
	}

	function notify()
	{
		$ret = NULL;
		$args = func_get_args();
		$name = strtolower(array_shift($args));
		if (!empty($this->_events[$name])) {
			foreach ($this->_events[$name] as $handler) {
				$tmp = call_user_func_array($handler, $args);
				if (!is_null($tmp)) {
					$ret = $tmp;
				}
			}
		}
		return $ret;
	}

	function notifyUntil()
	{
		$ret = NULL;
		$args = func_get_args();
		$name = strtolower(array_shift($args));
		if (!empty($this->_events[$name])) {
			foreach ($this->_events[$name] as $handler) {
				if(!is_null($ret = call_user_func_array($handler, $args))) {
					break;
				}
			}
		}
		return $ret;
	}
}
