<?php

error_reporting(-1);

function __autoload($className) {
    require './lib/' . strtolower($className) . '.php';
}

if (!isset($_GET['id'])) {
    exit('File id not set');
}
$id = intval($_GET['id']);

$config = require('./config/main.php');
$sizes  = require('./config/sizes.php');
$mime   = require('./config/mime.php');

$size = isset($_GET['size']) ? $_GET['size'] : 'square';
if (!isset($sizes[$size])) {
	die('No such size');
}

$manager = new FileRecordManager(array('uploadDir' => $config['uploadDir']));
$it = $manager->getIterator();
if (!$it->offsetExists($id)) {
	die('File not found');
}
$rec = $it->offsetGet($id);

if (strpos($rec['type'], 'image/') !== 0) {
	die('File is not image');
}

require './lib/imageview.php';

$params = array(
	'sizes'     => $sizes,
	'targetDir' => $config['thumbDir'],
	'typeByExt' => $mime,
	'id'        => $id,
	'size'      => $size);
$iv = new ImageView($params);

$fileName = $iv->targetName();
if (!file_exists($fileName)) {
	$iv->load($rec['target'])
	   ->resize($size)
	   ->save();
}

header('Location: /' . $fileName);